﻿using Newtonsoft.Json;
using SongVocalSectionAnalyser.Common.Logging.JsonConverters;
using SongVocalSectionAnalyser.Common.Logging.Model;
using System;

namespace SongVocalSectionAnalyser.Common.Logging
{
    public sealed class ConsoleLogger : LoggerBase
    {
        public static readonly ConsoleLogger Instance = new ConsoleLogger();

        private ConsoleLogger()
        {
        }

        protected override void WriteLog(LogEntry entry)
        {
            string dj;

            try
            {
                dj = entry.Details == null ? "" : JsonConvert.SerializeObject(entry.Details, LogJsonSerializerSettings.Default);
            }
            catch (Exception e)
            {
                var hold = entry.MakeCopyWithoutDetails();
                hold.Details = new { SerializationFail = e.Message, DowngradeToString = entry.Details?.ToString() };
                dj = JsonConvert.SerializeObject(hold, LogJsonSerializerSettings.Default);
            }

            Console.WriteLine($"{entry.Time}|{entry.Level}|{entry.Thread.Id}:{entry.Thread.Name}|{entry.Summary}|{dj}");
        }
    }
}
