﻿using System;
using System.Runtime.CompilerServices;

namespace SongVocalSectionAnalyser.Common.Logging
{
    /// <summary> 日志入口,可在运行时指定目标 </summary>
    public static class Logger
    {
        private static ILogger _target = ConsoleLogger.Instance;

        /// <summary> 指定日志目标 </summary>
        public static void Init(ILogger target)
        {
            if (target is DefaultLogger) throw new ArgumentException($"Can not use {nameof(DefaultLogger)}");
            _target = target;
        }

        [MethodImpl(MethodImplOptions.NoOptimization | MethodImplOptions.NoInlining)]
        public static void Debug(string summary, object details = null) => _target.Debug(summary, details);

        [MethodImpl(MethodImplOptions.NoOptimization | MethodImplOptions.NoInlining)]
        public static void Trace(string summary, object details = null) => _target.Trace(summary, details);

        [MethodImpl(MethodImplOptions.NoOptimization | MethodImplOptions.NoInlining)]
        public static void Info(string summary, object details = null) => _target.Info(summary, details);

        [MethodImpl(MethodImplOptions.NoOptimization | MethodImplOptions.NoInlining)]
        public static void Warn(string summary, object details = null) => _target.Warn(summary, details);

        [MethodImpl(MethodImplOptions.NoOptimization | MethodImplOptions.NoInlining)]
        public static void Error(string summary, object details = null) => _target.Error(summary, details);

        [MethodImpl(MethodImplOptions.NoOptimization | MethodImplOptions.NoInlining)]
        public static void Fatal(string summary, object details = null) => _target.Fatal(summary, details);
    }
}
