using System.Linq;

namespace SongVocalSectionAnalyser.Common.Logging.Model
{
    public class LogStacktraceFrame
    {
        public string Assembly { get; set; }

        public string Method { get; set; }

        public LogStacktraceFrameLineInfo Line { get; set; }

        public LogStacktraceFrameArgument[] Arguments { get; set; }

        public override string ToString()
        {
            return $"{Method}({string.Join(",", Arguments.Select(p => $"{p.Type} {p.Name}"))}) @ {Line} @ {Assembly}";
        }
    }

    public class LogStacktraceFrameLineInfo
    {
        public string FileName { get; set; }
        public int Line { get; set; }
        public int Column { get; set; }
    }
}